//+------------------------------------------------------------------+
//|                                                        Chart.mqh |
//|                                   Copyright 2016, Vitalii Ananev |
//|                              tps://www.mql5.com/ru/users/vitales |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, aka Vitales"
#property link      "https://www.mql5.com/ru/users/vitales"
#property version   "1.00"
#property strict

enum EArrowCode
{
 ARROW_UP    = OBJ_ARROW_UP,
 ARROW_DOWN  = OBJ_ARROW_DOWN
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class Chart
{ 
private:
 
  string PreficsName;
  int    ChartId;
  string Name;
protected:

   void ObjectSetInt(int prop_id,long prop_value);
public:
                     Chart();
                    ~Chart();
   void Init(string Name,int Id);                    
   void SetName(string Name);                    
   void SetChartId(int Id);
   void DeleteAllObj();
   void DeleteObj(string name);
   void TrendLine(string name,datetime time1,double price1,datetime time2,double price2);
   void SetTrendLine(string name,datetime time1,double price1,datetime time2,double price2,color LColor,int Width);
   void SetTrendLine(string name,datetime time1,double price1,datetime time2,color LColor,int Width);
   void HLine(string name,double price);
   void VLine(string name,datetime time);
   void VLine(string name,datetime time,color LColor,int Width);
   void EventLabel(string name,datetime time,string text);
   void RightPriceLabel(string name,datetime time1,double price1);
   void RightPriceLabel(string name,datetime time1,double price1,color LColor,int Width);   
   void LeftPriceLabel(string name,datetime time1,double price1);
   void LeftPriceLabel(string name,datetime time1,double price1,color LColor,int Width);
   void SetStyle(string name,ENUM_LINE_STYLE Style);
   void SetColor(string name,color ObjColor);
   void SetWidth(string name,int width=1);
   void SetSelectable(string name,bool select=true);
   void SetBack(string name,bool Back=true);
   void SetRay(string name,bool Ray=true);
   void SetText(string name,string text,datetime time,double price,int FontSize,string Font,color Color);
   void SetTextLabel(string name,string text,int X,int Y, int Z, color Color,int FontSize=8,string Font="Wingdings");   
   void SetRect(string name,datetime time1,double price1,datetime time2,double price2,color Color);
   void SetRectLabel(string name,int X=0,int Y=0,int Width=50,int Height=20,color BackColor = C'236,233,216',ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, ENUM_BORDER_TYPE border=BORDER_SUNKEN);
   void SetArrow(string name,datetime time1,double price1,int Code,color Color);
  // void SetArrow(string name,datetime time1,double price1,EArrowCode Code,color Color);
   void SetRegression(string name,datetime time1,datetime time2,color Color,int Width=1,bool Ray = false);
};

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
Chart::Chart()
{
   PreficsName = "chart";   
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
Chart::~Chart()
{
}
//+------------------------------------------------------------------+

void Chart::ObjectSetInt(int prop_id,long prop_value)
{
    if (ObjectFind(ChartId,PreficsName+Name)!=-1)
    {
       ObjectSetInteger(ChartId,PreficsName+Name,prop_id,prop_value);
    }
}

void Chart::Init(string name,int Id)
{
   SetName(name);
   SetChartId(Id);
}

void Chart::SetName(string name)
{
   if (PreficsName!=name) PreficsName = name;
}

void Chart::SetChartId(int Id)
{
   if (ChartId!=Id) ChartId = Id;
}

void Chart::TrendLine(string name,datetime time1,double price1,datetime time2,double price2)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_TREND, 0, time1, price1, time2,price2);
    //  ObjectSet(PreficsName+name,OBJPROP_RAY,false);
    //  ObjectSet(PreficsName+name, OBJPROP_WIDTH,width); 
     // ObjectSet(PreficsName+name,OBJPROP_COLOR,TColor);
     // ObjectSet(PreficsName+name, OBJPROP_STYLE,STYLE_SOLID); 
     // ObjectSet(PreficsName+name,OBJPROP_BACK,true);      
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time1,price1);
      ObjectMove(ChartId,PreficsName+name,1,time2,price2);
    } 
}

void Chart::SetTrendLine(string name,datetime time1,double price1,datetime time2,double price2,color LColor,int Width)
{
   TrendLine(name,time1,price1,time2,price2);
   SetColor(name,LColor);
   SetWidth(name,Width);
  // SetRay(name,false);    
}

void Chart::SetTrendLine(string name,datetime time1,double price1,datetime time2,color LColor,int Width)
{
   TrendLine(name,time1,price1,time2,price1);
   SetColor(name,LColor);
   SetWidth(name,Width);    
   SetRay(name,false);
}


void Chart::HLine(string name,double price)
{   
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {   
      ObjectCreate(ChartId,PreficsName+name, OBJ_HLINE, 0, 0, price);
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,0,price);
      
    } 
}

void Chart::VLine(string name,datetime time)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_VLINE, 0, time, 0);
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time,0);      
    } 
}

void Chart::VLine(string name,datetime time,color LColor,int Width)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_VLINE, 0, time, 0);
      SetColor(name,LColor);
      SetWidth(name,Width);    

    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time,0);
      
    } 
}


void Chart::EventLabel(string name,datetime time,string text)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_EVENT, 0, time, 0);
      ObjectSetString(ChartId,PreficsName+name,OBJPROP_TEXT,text); 
    //  ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_BACK,true);
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time,0);     
    } 
}


void Chart::RightPriceLabel(string name,datetime time1,double price1)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_ARROW_RIGHT_PRICE, 0, time1, price1);
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time1,price1);      
    } 
}

void Chart::RightPriceLabel(string name,datetime time1,double price1,color LColor,int Width)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_ARROW_RIGHT_PRICE, 0, time1, price1);
      SetColor(name,LColor);
      SetWidth(name,Width);
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time1,price1);      
      SetColor(name,LColor);
      SetWidth(name,Width);      
    } 
}


void Chart::LeftPriceLabel(string name,datetime time1,double price1)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_ARROW_LEFT_PRICE, 0, time1, price1);
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time1,price1);      
    } 
}

void Chart::LeftPriceLabel(string name,datetime time1,double price1,color LColor,int Width)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_ARROW_LEFT_PRICE, 0, time1, price1);
      SetColor(name,LColor);
      SetWidth(name,Width);      
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time1,price1);      
      SetColor(name,LColor);
      SetWidth(name,Width);      
      
    } 
}


void Chart::SetStyle(string name,ENUM_LINE_STYLE Style)
{
   Name = name;
   ObjectSetInt(OBJPROP_STYLE,Style); 
}

void Chart::SetColor(string name,color ObjColor)
{
   Name = name;
   ObjectSetInt(OBJPROP_COLOR,ObjColor); 
}

void Chart::SetWidth(string name,int width=1)
{
   //if (ObjectGetInteger(ChartId,PreficsName+name,OBJPROP_STYLE)==STYLE_SOLID)
   Name = name;
   ObjectSetInt(OBJPROP_WIDTH,width); 
}

void Chart::SetSelectable(string name,bool select=true)
{
   Name = name;
   ObjectSetInt(OBJPROP_SELECTABLE,select); 
}

void Chart::SetBack(string name,bool Back=true)
{
   Name = name;
   ObjectSetInt(OBJPROP_BACK,Back); 
}

void Chart::SetRay(string name,bool Ray=true)
{
   Name = name;
   ObjectSetInt(OBJPROP_RAY,Ray); 
}

void Chart::DeleteAllObj()
{
    string obj_name = "";
    
    for(int i=ObjectsTotal()-1;i>=0;i--)
    {
        obj_name = ObjectName(i);
        if(StringFind(obj_name,PreficsName,0)== 0) ObjectDelete(obj_name);
    }    
}

void Chart::DeleteObj(string name)
{
   ObjectDelete(ChartId,PreficsName+name);
}

void Chart::SetText(string name,string text,datetime time,double price,int FontSize,string Font,color Color)
{
    bool res = false;
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      res = ObjectCreate(ChartId,PreficsName+name, OBJ_TEXT, 0, time, price);
    } else
    {
      res = ObjectMove(ChartId,PreficsName+name,0,time,price);
    } 
    if (res)
    {
      ObjectSetString(ChartId,PreficsName+name,OBJPROP_TEXT,text);  
      ObjectSetString(ChartId,PreficsName+name,OBJPROP_FONT,Font); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_FONTSIZE,FontSize);        
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_COLOR,Color);
      //ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_ANCHOR,anchor);ANCHOR_BOTTOM 
 
   }
  //ObjectCreate(name, OBJ_TEXT,0, 0, 0);
  //ObjectSet(name, OBJPROP_CORNER, Corner);
  //ObjectSet(name, OBJPROP_XDISTANCE, 10);
  //ObjectSet(name, OBJPROP_YDISTANCE, 2);     

}

void Chart::SetTextLabel(string name,string text,int X,int Y, int Z, color Color,int FontSize=8,string Font="Wingdings")
{
   bool res = false;
   if (ObjectFind(ChartId,PreficsName+name)==-1)
   {
      res = ObjectCreate(ChartId,PreficsName+name, OBJ_LABEL, 0, 0, 0);
      ObjectSetString(ChartId,name,OBJPROP_TEXT,text);
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_XDISTANCE,X); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_YDISTANCE,Y); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_CORNER,Z);  
      ObjectSetString(ChartId,PreficsName+name,OBJPROP_TEXT,text);  
      ObjectSetString(ChartId,PreficsName+name,OBJPROP_FONT,Font); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_FONTSIZE,FontSize);        
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_COLOR,Color);        
      
   }
   else
   {
      ObjectSetString(ChartId,name,OBJPROP_TEXT,text);
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_XDISTANCE,X); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_YDISTANCE,Y); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_CORNER,Z);  
      ObjectSetString(ChartId,PreficsName+name,OBJPROP_TEXT,text);  
      ObjectSetString(ChartId,PreficsName+name,OBJPROP_FONT,Font); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_FONTSIZE,FontSize);        
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_COLOR,Color);        
   }
}


void Chart::SetRect(string name,datetime time1,double price1,datetime time2,double price2,color Color)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_RECTANGLE, 0, time1, price1, time2,price2);
      SetColor(name,Color);
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time1,price1);
      ObjectMove(ChartId,PreficsName+name,1,time2,price2);
      SetColor(name,Color);
    } 
}

void Chart::SetRectLabel(string name,int X=0,int Y=0,int Width=50,int Height=20,color BackColor=14215660,ENUM_BASE_CORNER corner=0,ENUM_BORDER_TYPE border=2)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_RECTANGLE_LABEL, 0, 0,0);
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_XDISTANCE,X); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_YDISTANCE,Y); 
   
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_XSIZE,Width); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_YSIZE,Height); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_BGCOLOR,BackColor);    
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_BORDER_TYPE,border); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_CORNER,corner);       
      //SetColor(name,Color);
    } else
    {
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_XDISTANCE,X); 
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_YDISTANCE,Y); 
      //SetColor(name,Color);
    } 

}

void Chart::SetArrow(string name,datetime time,double price,int Code,color Color)
{
    bool res = false;
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      res = ObjectCreate(ChartId,PreficsName+name, OBJ_ARROW, 0, time, price);
    } else
    {
      res = ObjectMove(ChartId,PreficsName+name,0,time,price);
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_COLOR,Color);
    } 
    if (res)
    {
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_ARROWCODE,Code);  
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_COLOR,Color);
   }
}
/*
void Chart::SetArrow(string name,datetime time,double price,EArrowCode Code,color Color)
{
    bool res = false;
  //  ENUM_OBJECT k = Code;
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      res = ObjectCreate(ChartId,PreficsName+name, (ENUM_OBJECT)Code, 0, time, price);
    } else
    {
      res = ObjectMove(ChartId,PreficsName+name,0,time,price);
      ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_COLOR,Color);
    } 
 //   if (res)
   // {
     // ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_ARROWCODE,Code);  
     // ObjectSetInteger(ChartId,PreficsName+name,OBJPROP_COLOR,Color);
  // }
}
*/
void Chart::SetRegression(string name,datetime time1,datetime time2,color Color,int Width=1,bool Ray=false)
{
    if (ObjectFind(ChartId,PreficsName+name)==-1)
    {
      ObjectCreate(ChartId,PreficsName+name, OBJ_REGRESSION, 0, time1,0, time2,0);
      SetColor(name,Color);
      SetWidth(name,Width);
      SetRay(name,Ray);
    } else
    {
      ObjectMove(ChartId,PreficsName+name,0,time1,0);      
      ObjectMove(ChartId,PreficsName+name,1,time2,0);
      SetColor(name,Color);
      SetWidth(name,Width); 
      SetRay(name,Ray);     
    } 
}
